import os
import gtk
import gtk.glade
import platform

import os

class Mem(object):
    _proc_status = '/proc/%d/status' % os.getpid()
    _scale = {'kB': 1024.0, 'mB': 1024.0*1024.0,
              'KB': 1024.0, 'MB': 1024.0*1024.0}

    def __repr__(self):
        return "%.2f" % (self/1000000)

    def _VmB(self, VmKey):
        '''Private.
        '''
         # get pseudo file  /proc/<pid>/status
        try:
            t = open(self._proc_status)
            v = t.read()
            t.close()
        except:
            return 0.0  # non-Linux?
         # get VmKey line e.g. 'VmRSS:  9999  kB\n ...'
        i = v.index(VmKey)
        v = v[i:].split(None, 3)  # whitespace
        if len(v) < 3:
            return 0.0  # invalid format?
         # convert Vm value to bytes
        return (int(v[1]) * self._scale[v[2]]/1000000.0)


    def size(self, since=0.0):
        return "%.3f" % (self._VmB('VmSize:') - since)

    def rss(self, since=0.0):
        return "%.3f" % (self._VmB('VmRSS:') - since)


try:
    import psutil2
    p = psutil.Process(os.getpid())
    print os.getpid()
    def mem():
        return " ".join("%.3f" % (x/1000000.0) for x in p.get_memory_info())
except ImportError:
    if platform.system() == 'Linux':
        mem = Mem().rss
    else:
        mem = lambda: "Devi leggere la ram con gli strumenti del tuo OS"

def new_windows(win):
    for i in range(5):
        w_tree = gtk.glade.XML(gladefile) 
        w = w_tree.get_widget("Window")
        w.show_all()
        wins.append(w)
    print mem()
    
def kill(win):
    for i in wins:
        i.destroy()
    del wins[:]

wins = []
gladefile='/tmp/gg.glade'
gladefile='/tmp/g2.glade'

w_tree = gtk.glade.XML(gladefile) 
k = w_tree.get_widget("kill")
a = w_tree.get_widget("ancora")
w = w_tree.get_widget("Window")
w.show_all()

k.connect('clicked', kill)
a.connect('clicked', new_windows)

for x in range(12):
    new_windows(None)
    kill(None)

gtk.main()
