import gc
import sys
import inspect
import weakref

import gtk
import memory
import os

from sqlkit.widgets import SqlTable, SqlMask
from sqlkit.db import proxy
import model
#import objgraph

import psutil
p = psutil.Process(os.getpid())
def mem():
    print " ".join("%.2f" % (x/1000000.0) for x in p.get_memory_info())

db = proxy.DbProxy(bind="sqlite:///model/db.sqlite")
refs = {}

def mmem():
    print memory.memory()

def show_object(o):
    if isinstance(o, dict):
        for i, o2 in enumerate(gc.get_referrers(o)):
            if not inspect.isframe(o2):
                if isinstance(o2, list):
                    continue
                print "Dict (%s)" % i,  str(o2)[:110]
    else:
        print o

    

def show_referrers(obj):
    for o in gc.get_referrers(obj):
        show_object(o)
        

def go(sqlwidget, *args):
    global m
    global refs
    global name
    key = None # 'tb-gtk-close'
    if hasattr(sqlwidget, '_mask'):
        m = sqlwidget._mask
        print "m=", m

    gc.collect()
    print "MEM", mem()
    for k in refs:
        print "  Key: %s  => %s" % (k, refs[k]())

    if key and key in refs:
        ref = refs[key]
        if ref():
            print "Chi tiene in vita ", ref()
            show_referrers(ref())
            return
        
    try:
        o = m()
        if not o:
            print "Mask is not referenced", m
        else:
            print "Reimposto refs"
            refs = {
                'o' : weakref.ref(o) ,
                #'' : weakref.ref(o.records),
                'filter_panel' : weakref.ref(o.filter_panel),
                'tb-gtk-close' : weakref.ref(o.filter_panel.w['tb=gtk-close']),
                'description-widget'  : weakref.ref(o.gui_fields['description'].widget),
                'description-field'  : weakref.ref(o.gui_fields['description']),
                'lay_obj'  : weakref.ref(o.lay_obj),
                'l.cont'  : weakref.ref(o.lay_obj.container),
                }

            if key:
                ref = refs[key]
                if ref():
                    show_referrers(ref())

    except NameError, e:
        print "m non definito", e

def go2():
    print len(gc.get_objects())
    #for o in gc.get_objects():
    #    show_object(o)

print len(gc.get_objects())

t = SqlTable('movie',    dbproxy=db, order_by='title', )
t.reload()
t.connect_after('button-press-event', go)



try:
    gtk.main()
except KeyboardInterrupt:
    go2()
    #objgraph.show_backrefs(m())
    
    

