import gc
import inspect

import gtk

from sqlkit.widgets import SqlTable
from sqlkit.db import proxy
import model

def gc_start():
    global objects_id
    gc.collect()
    objects = gc.get_objects()
    objects_id = {}
    for o in objects:
        objects_id[id(o)] = True

# def gc_show(obj):
#     for o in l:
#         print o
#         if verbose >= 2:
#             if o in gc.garbage:
#                 print o
#                 print "    In gc.garbage (possible cause: presence of __del__ method)"
#             else:
#                 cold_trail, lines = show_referrers(o, [id(o)], 1)
#                 for line in lines:
#                     print line

def show_referrers(initial_object, backrefs=None, level=1):
    if not backrefs:
        backrefs = [id(initial_object)]
    cold_trail = True
    lines = []

    for o in gc.get_referrers(initial_object):
        bump = 0
        if (id(o) in backrefs):
            # cyclical reference to an object of the trail
            continue
        elif (id(o) not in objects_id):
            # object created within this very routine
            continue

        if isinstance(o, (type,)) or inspect.ismodule(o) or inspect.isfunction(o):
            # dead end, but at least we are 100% sure this trail does not lead to a cycle
            # lines.append("  "*(level+1) + str(type(o)) + " " + str(o)[0:80])
            cold_trail = False
            continue
        
        if False: # isinstance(o, (BufferType)):
            # uninteresting to print, but must be followed
            pass
        else:
            lines.append("  "*(level+1) + str(type(o)) + " " + str(o)[0:80])
            bump = 1
            
        if len(backrefs) < 8:
            backrefs_new = backrefs[:]
            backrefs_new.append(id(o))
            referrers_are_cold_trails, referrers_lines = \
                                       show_referrers(o, backrefs_new, level+bump)
            lines.extend(referrers_lines)
            cold_trail = cold_trail and referrers_are_cold_trails

    if cold_trail:
        # our introspection was worthless because only lead to cyclical refs
        lines = []
        
    return (cold_trail, lines)

db = proxy.DbProxy(bind="sqlite:///model/db.sqlite")

t = SqlTable('movie',    dbproxy=db, order_by='title', )
t.reload()





gtk.main()

